"""
    Adyen for Platforms: Account API

    The Account API provides endpoints for managing account-related entities on your platform. These related entities include account holders, accounts, bank accounts, shareholders, and KYC-related documents. The management operations include actions such as creation, retrieval, updating, and deletion of them.  For more information, refer to our [documentation](https://docs.adyen.com/platforms). ## Authentication To connect to the Account API, you must use basic authentication credentials of your web service user. If you don't have one, contact the [Adyen Support Team](https://support.adyen.com/hc/en-us/requests/new). Then use its credentials to authenticate your request, for example:  ``` curl -U \"ws@MarketPlace.YourMarketPlace\":\"YourWsPassword\" \\ -H \"Content-Type: application/json\" \\ ... ``` Note that when going live, you need to generate new web service user credentials to access the [live endpoints](https://docs.adyen.com/development-resources/live-endpoints).  ## Versioning The Account API supports versioning of its endpoints through a version suffix in the endpoint URL. This suffix has the following format: \"vXX\", where XX is the version number.  For example: ``` https://cal-test.adyen.com/cal/services/Account/v6/createAccountHolder ```  # noqa: E501

    The version of the OpenAPI document: 6
    Contact: developer-experience@adyen.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from adyen_account.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from adyen_account.exceptions import ApiAttributeError


def lazy_import():
    from adyen_account.model.bank_account_detail import BankAccountDetail
    from adyen_account.model.business_details import BusinessDetails
    from adyen_account.model.individual_details import IndividualDetails
    from adyen_account.model.legal_arrangement_detail import LegalArrangementDetail
    from adyen_account.model.payout_method import PayoutMethod
    from adyen_account.model.store_detail import StoreDetail
    from adyen_account.model.vias_address import ViasAddress
    globals()['BankAccountDetail'] = BankAccountDetail
    globals()['BusinessDetails'] = BusinessDetails
    globals()['IndividualDetails'] = IndividualDetails
    globals()['LegalArrangementDetail'] = LegalArrangementDetail
    globals()['PayoutMethod'] = PayoutMethod
    globals()['StoreDetail'] = StoreDetail
    globals()['ViasAddress'] = ViasAddress


class AccountHolderDetails(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'email': (str,),  # noqa: E501
            'full_phone_number': (str,),  # noqa: E501
            'web_address': (str,),  # noqa: E501
            'address': (ViasAddress,),  # noqa: E501
            'bank_account_details': ([BankAccountDetail],),  # noqa: E501
            'bank_aggregator_data_reference': (str,),  # noqa: E501
            'business_details': (BusinessDetails,),  # noqa: E501
            'individual_details': (IndividualDetails,),  # noqa: E501
            'legal_arrangements': ([LegalArrangementDetail],),  # noqa: E501
            'merchant_category_code': (str,),  # noqa: E501
            'metadata': ({str: (str,)},),  # noqa: E501
            'payout_methods': ([PayoutMethod],),  # noqa: E501
            'principal_business_address': (ViasAddress,),  # noqa: E501
            'store_details': ([StoreDetail],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'email': 'email',  # noqa: E501
        'full_phone_number': 'fullPhoneNumber',  # noqa: E501
        'web_address': 'webAddress',  # noqa: E501
        'address': 'address',  # noqa: E501
        'bank_account_details': 'bankAccountDetails',  # noqa: E501
        'bank_aggregator_data_reference': 'bankAggregatorDataReference',  # noqa: E501
        'business_details': 'businessDetails',  # noqa: E501
        'individual_details': 'individualDetails',  # noqa: E501
        'legal_arrangements': 'legalArrangements',  # noqa: E501
        'merchant_category_code': 'merchantCategoryCode',  # noqa: E501
        'metadata': 'metadata',  # noqa: E501
        'payout_methods': 'payoutMethods',  # noqa: E501
        'principal_business_address': 'principalBusinessAddress',  # noqa: E501
        'store_details': 'storeDetails',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, email, full_phone_number, web_address, *args, **kwargs):  # noqa: E501
        """AccountHolderDetails - a model defined in OpenAPI

        Args:
            email (str): The email address of the account holder.
            full_phone_number (str): The phone number of the account holder provided as a single string. It will be handled as a landline phone. **Examples:** \"0031 6 11 22 33 44\", \"+316/1122-3344\", \"(0031) 611223344\"
            web_address (str): The URL of the website of the account holder.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            address (ViasAddress): [optional]  # noqa: E501
            bank_account_details ([BankAccountDetail]): Array of bank accounts associated with the account holder. For details about the required `BankAccountDetail` fields, refer to [Bank account check](https://docs.adyen.com/platforms/verification-checks/bank-account-check).. [optional]  # noqa: E501
            bank_aggregator_data_reference (str): The opaque reference value returned by the Adyen API during bank account login.. [optional]  # noqa: E501
            business_details (BusinessDetails): [optional]  # noqa: E501
            individual_details (IndividualDetails): [optional]  # noqa: E501
            legal_arrangements ([LegalArrangementDetail]): Array that contains information about legal arrangements, used when the account holder is acting on behalf of different parties or is part of a contractual business agreement.. [optional]  # noqa: E501
            merchant_category_code (str): The Merchant Category Code of the account holder. > If not specified in the request, this will be derived from the platform account (which is configured by Adyen).. [optional]  # noqa: E501
            metadata ({str: (str,)}): A set of key and value pairs for general use by the account holder or merchant. The keys do not have specific names and may be used for storing miscellaneous data as desired. > The values being stored have a maximum length of eighty (80) characters and will be truncated if necessary. > Note that during an update of metadata, the omission of existing key-value pairs will result in the deletion of those key-value pairs.. [optional]  # noqa: E501
            payout_methods ([PayoutMethod]): Array of tokenized card details associated with the account holder. For details about how you can use the tokens to pay out, refer to [Pay out to cards](https://docs.adyen.com/platforms/payout-to-cards).. [optional]  # noqa: E501
            principal_business_address (ViasAddress): [optional]  # noqa: E501
            store_details ([StoreDetail]): Array of stores associated with the account holder. Required when onboarding account holders that have an Adyen [point of sale](https://docs.adyen.com/platforms/platforms-for-pos).. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.email = email
        self.full_phone_number = full_phone_number
        self.web_address = web_address
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, email, full_phone_number, web_address, *args, **kwargs):  # noqa: E501
        """AccountHolderDetails - a model defined in OpenAPI

        Args:
            email (str): The email address of the account holder.
            full_phone_number (str): The phone number of the account holder provided as a single string. It will be handled as a landline phone. **Examples:** \"0031 6 11 22 33 44\", \"+316/1122-3344\", \"(0031) 611223344\"
            web_address (str): The URL of the website of the account holder.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            address (ViasAddress): [optional]  # noqa: E501
            bank_account_details ([BankAccountDetail]): Array of bank accounts associated with the account holder. For details about the required `BankAccountDetail` fields, refer to [Bank account check](https://docs.adyen.com/platforms/verification-checks/bank-account-check).. [optional]  # noqa: E501
            bank_aggregator_data_reference (str): The opaque reference value returned by the Adyen API during bank account login.. [optional]  # noqa: E501
            business_details (BusinessDetails): [optional]  # noqa: E501
            individual_details (IndividualDetails): [optional]  # noqa: E501
            legal_arrangements ([LegalArrangementDetail]): Array that contains information about legal arrangements, used when the account holder is acting on behalf of different parties or is part of a contractual business agreement.. [optional]  # noqa: E501
            merchant_category_code (str): The Merchant Category Code of the account holder. > If not specified in the request, this will be derived from the platform account (which is configured by Adyen).. [optional]  # noqa: E501
            metadata ({str: (str,)}): A set of key and value pairs for general use by the account holder or merchant. The keys do not have specific names and may be used for storing miscellaneous data as desired. > The values being stored have a maximum length of eighty (80) characters and will be truncated if necessary. > Note that during an update of metadata, the omission of existing key-value pairs will result in the deletion of those key-value pairs.. [optional]  # noqa: E501
            payout_methods ([PayoutMethod]): Array of tokenized card details associated with the account holder. For details about how you can use the tokens to pay out, refer to [Pay out to cards](https://docs.adyen.com/platforms/payout-to-cards).. [optional]  # noqa: E501
            principal_business_address (ViasAddress): [optional]  # noqa: E501
            store_details ([StoreDetail]): Array of stores associated with the account holder. Required when onboarding account holders that have an Adyen [point of sale](https://docs.adyen.com/platforms/platforms-for-pos).. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.email = email
        self.full_phone_number = full_phone_number
        self.web_address = web_address
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
